#include <bits/stdc++.h>
#include <bits/extc++.h>

#ifndef DEBUG
#define endl '\n'
#endif

using namespace std;
using ll = long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;

void solve();

int main() {
#ifdef DEBUG
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(22);

//    ll t;
//    cin >> t;
//    while (t--)
    solve();
}

template<class A, class B>
istream &operator>>(istream &s, pair<A, B> &p) {
    return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
    for (auto &e: v) s >> e;
    return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
    for (auto &e: v) s << e << ' ';
    return s;
}

ll sqrti(ll x) {
    ll L = 0, R = 1e9 + 10;
    while (R - L > 1) {
        ll M = (L + R) / 2;
        (M * M > x ? R : L) = M;
    }
    return L;
}

#define BAIL(...) { \
  cout << (__VA_ARGS__) << endl; \
  return; \
}void(0)

using sl = __int128_t;

vi xs, ys;

class segtree {
public:
    void build(ll n_) {
        n = 1ll << (ll) (ceil(log2(n_)));
        tree.resize(2 * n);
        mod.resize(2 * n);
        build(1, 0, n);
    }

    ll query(ll l, ll r) {
        ll len = ys[r] - ys[l];
        ii res = query(1, 0, n, l, r);
        if (res.first != 0) return len;
        return (len - res.second);
    }

    void update(ll l, ll r, ll x) {
        update(1, 0, n, l, r, x);
    }

private:
    ll n{};
    vii tree;
    vi mod;

    void build(ll v, ll l, ll r) {
        if (l + 1 == r) {
            if (r < ys.size()) {
                tree[v] = {0, ys[r] - ys[l]};
            } else {
                tree[v] = {1e18, 0};
            }
            return;
        }
        ll m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v + 1, m, r);
        pull(v);
    }

    ii query(ll v, ll l, ll r, ll ql, ll qr) {
        if (ql <= l && r <= qr) {
            return getval(v);
        }
        if (qr <= l || r <= ql) {
            return {0, 0};
        }
        push(v);
        ll m = (l + r) / 2;
        ii a = query(2 * v, l, m, ql, qr);
        ii b = query(2 * v + 1, m, r, ql, qr);
        pull(v);
        return merge(a, b);
    }

    void update(ll v, ll l, ll r, ll ql, ll qr, ll x) {
        if (ql <= l && r <= qr) {
            mod[v] += x;
            return;
        }
        if (qr <= l || r <= ql) {
            return;
        }
        push(v);
        ll m = (l + r) / 2;
        update(2 * v, l, m, ql, qr, x);
        update(2 * v + 1, m, r, ql, qr, x);
        pull(v);
    }

    void push(ll v) {
        mod[2 * v] += mod[v];
        mod[2 * v + 1] += mod[v];
        mod[v] = 0;
    }

    ii merge(ii a, ii b) {
        if (a.first == b.first) {
            return {a.first, a.second + b.second};
        }
        return min(a, b);
    }

    void pull(ll v) {
        tree[v] = merge(getval(2 * v), getval(2 * v + 1));
    }

    ii getval(ll v) {
        return {tree[v].first + mod[v], tree[v].second};
    }
};

void solve() {
    ll k, n;
    cin >> k >> n;
    vector<pair<char, ll>> cmds(n);
    cin >> cmds;

    vector<tuple<ll, ll, ll, ll>> rects;

    {
        ii pos = {0, 0};
        for (auto [dir, len]: cmds) {
            ii orig = pos;

            if (dir == 'N') pos.second += len;
            if (dir == 'S') pos.second -= len;
            if (dir == 'E') pos.first += len;
            if (dir == 'W') pos.first -= len;

            vii all;

            for (auto [x, y]: {orig, pos}) {
                all.emplace_back(x, y);
                all.emplace_back(x, y + k);
                all.emplace_back(x + k, y);
                all.emplace_back(x + k, y + k);
            }

            sort(all.begin(), all.end());

            rects.emplace_back(all.front().first, all.front().second, all.back().first, all.back().second);
        }
    }

    {
        for (auto [x1, y1, x2, y2]: rects) {
            xs.emplace_back(x1);
            ys.emplace_back(y1);
            xs.emplace_back(x2);
            ys.emplace_back(y2);
        }
        sort(xs.begin(), xs.end());
        xs.resize(unique(xs.begin(), xs.end()) - xs.begin());
        sort(ys.begin(), ys.end());
        ys.resize(unique(ys.begin(), ys.end()) - ys.begin());

        for (auto &[x1, y1, x2, y2]: rects) {
            x1 = lower_bound(xs.begin(), xs.end(), x1) - xs.begin();
            y1 = lower_bound(ys.begin(), ys.end(), y1) - ys.begin();
            x2 = lower_bound(xs.begin(), xs.end(), x2) - xs.begin();
            y2 = lower_bound(ys.begin(), ys.end(), y2) - ys.begin();
        }
    }

    using event = tuple<ll, bool, ll, ll>;

    vector<event> events;
    for (auto [x1, y1, x2, y2]: rects) {
        events.emplace_back(x1, true, y1, y2);
        events.emplace_back(x2, false, y1, y2);
    }

    sort(events.begin(), events.end());

    ll ans = 0;

    segtree st;
    st.build(ys.size());

    ll last_x = xs[0];
    for (auto [x, start, y1, y2]: events) {
        ll dist = xs[x] - last_x;

        ans += dist * st.query(0, ys.size() - 1);

        st.update(y1, y2, start ? +1 : -1);

        last_x = xs[x];
    }

    cout << ans << endl;
}