#include <bits/stdc++.h>
#include <bits/extc++.h>

#ifndef DEBUG
#define endl '\n'
#endif

using namespace std;
using ll = long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vb = vector<bool>;
using ld = long double;
using vvb = vector<vb>;

void solve();

int main() {
#ifdef DEBUG
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(22);

//    ll t;
//    cin >> t;
//    while (t--)
    solve();
}

template<class A, class B>
istream &operator>>(istream &s, pair<A, B> &p) {
    return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
    for (auto &e: v) s >> e;
    return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
    for (auto &e: v) s << e << ' ';
    return s;
}

ll sqrti(ll x) {
    ll L = 0, R = 1e9 + 10;
    while (R - L > 1) {
        ll M = (L + R) / 2;
        (M * M > x ? R : L) = M;
    }
    return L;
}

#define BAIL(...) { \
  cout << (__VA_ARGS__) << endl; \
  return; \
}void(0)

using sl = __int128_t;

ll n, t;

ii sub(const ii &a, const ii &b) {
    return {a.first - b.first, a.second - b.second};
}

ll cross(const ii &a, const ii &b) {
    return a.first * b.second - a.second * b.first;
}

ll dot(const ii &a, const ii &b) {
    return a.first * b.first + a.second * b.second;
}

const ld pi = acosl(-1);
const ld eps = 1e-18;

ld pran(ld a) {
    a += 2 * 2 * pi;
    while (a > 2 * pi - eps) {
        a -= 2 * pi;
    }
    return a;
}

ii calc_next(ll i, ll j, vii a) {
    vii orig = a;

    ii vec = sub(a[j], a[i]);
    if (j != 0) {
        swap(a[j], a[0]);
    }
    const auto &o = a[0];
    sort(a.begin() + 1, a.end(), [&](auto a, auto b) -> bool {
        a = sub(a, o);
        b = sub(b, o);
        if (cross(a, b) == 0) {
            return a.first * a.first + a.second * a.second < b.first * b.first + b.second * b.second;
        }
        // ya dumal mojno i bez atan'a, chet zabil
        ld vt = atan2l(vec.second, vec.first);
        ld at = atan2l(a.second, a.first);
        ld bt = atan2l(b.second, b.first);

        at -= vt;
        bt -= vt;
        return pran(at) < pran(bt);
    });

    return {j, find(orig.begin(), orig.end(), a[1 + t]) - orig.begin()};
}

vi next_v;

vi used;
vb in_cycle;
vi depth;
vvb visited;

vi trace;

ll dfs(ll v, ll d = 0) {
    used[v] = 1;
    depth[v] = d;
    trace.emplace_back(v);

    ll ret = 1e18;

    ll u = next_v[v];
    if (used[u] == 0) {
        ret = min(ret, dfs(u, d + 1));
    } else if (used[u] == 1) {
        ret = min(ret, depth[u]);
    }

    if (ret <= d) {
        in_cycle[v] = true;
    }

    visited[v][u / n] = true;

    if (!in_cycle[v]) {
        for (ll i = 0; i < n; ++i) {
            if (visited[u][i]) visited[v][i] = true;
        }
    } else {
        for (auto e: trace) {
            if (ret <= depth[e]) {
                visited[v][e / n] = true;
            }
        }
    }

    used[v] = 2;
    trace.pop_back();

    return ret;
}

void solve() {
    cin >> n >> t;
    t -= 1;
    vii a(n);
    cin >> a;

//    ll i, j;
//    cin >> i >> j;
//    --i, --j;
//    auto [x, y] = calc_next(i, j, a);
//    cout << x + 1 << ' ' << y + 1 << endl;

    next_v.resize(n * n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) continue;
            auto [x, y] = calc_next(i, j, a);
            ll v = i * n + j;
            ll u = x * n + y;
            next_v[v] = u;
        }
    }

    used.resize(n * n);
    in_cycle.resize(n * n);
    depth.resize(n * n);
    visited.resize(n * n, vb(n));

    for (int i = 0; i < n * n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }

    string ans(n, '?');
    for (int i = 0; i < n; ++i) {
        bool cyc = false;
        bool vis = false;
        for (int j = 0; j < n; ++j) {
            if (i == j) continue;
            ll v = i * n + j;
            if (in_cycle[v]) {
                cyc = true;
                break;
            }
            if (visited[v][i]) {
                vis = true;
            }
        }
        if (cyc) {
            ans[i] = 'G';
        } else if (vis) {
            ans[i] = 'B';
        } else {
            ans[i] = 'R';
        }
    }

    cout << ans << endl;
}