#include <bits/extc++.h>

using namespace std;
using ll = long long;
using ii = pair<ll, ll>;
using vi = vector<ll>;
using vb = vector<bool>;
using vvi = vector<vi>;
using vii = vector<ii>;
using vvii = vector<vii>;
using vvb = vector<vb>;
using ld = long double;

void solve();

int main() {
#ifdef DEBUG
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(25);

    solve();
}

template<class A, class B, class C>
istream &operator>>(istream &s, tuple<A, B, C> &t) {
    return s >> get<0>(t) >> get<1>(t) >> get<2>(t);
}

template<class A, class B>
istream &operator>>(istream &s, pair<A, B> &p) {
    return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
    for (auto &e: v) s >> e;
    return s;
}

void solve() {
    ll n, p;
    cin >> n >> p;
    vector<tuple<ll, ll, ll>> ar(n);
    cin >> ar;

    auto eval = [&](ll x) -> ll {
        ll sum = 0;
        for (auto [z, a, b]: ar) {
            if (x <= z) {
                sum += a * x;
            } else {
                sum += a * z + b * (x - z);
            }
        }
        return sum;
    };

    ll L = 0, R = 1e14;
    while (R - L > 1) {
        ll M = (L + R) / 2;
        (eval(M) < p ? L : R) = M;
    }
    cout << R << endl;
}