#include <bits/extc++.h>

using namespace std;
using ll = long long;
using ii = pair<ll, ll>;
using vi = vector<ll>;
using vb = vector<bool>;
using vvi = vector<vi>;
using vii = vector<ii>;
using vvii = vector<vii>;
using vvb = vector<vb>;
using ld = long double;

void solve();

int main() {
#ifdef DEBUG
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(25);

    solve();
}

template<class A, class B, class C>
istream &operator>>(istream &s, tuple<A, B, C> &t) {
    return s >> get<0>(t) >> get<1>(t) >> get<2>(t);
}

template<class A, class B>
istream &operator>>(istream &s, pair<A, B> &p) {
    return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
    for (auto &e: v) s >> e;
    return s;
}

#ifndef DEBUG
#define endl '\n'
#endif

using si = __int128_t;

constexpr ll mod = 1e9 + 7;

ll ipow(ll b, ll e) {
    ll res = 1;
    for (int i = 0; i < e; ++i) {
        res *= b;
    }
    return res;
}


void solve() {
    ll n, m;
    cin >> n >> m;

    vi a(m);
    cin >> a;
    sort(a.begin(), a.end());

    if (m == 2) {
        vvi dp(n + 1, vi(2));

        ll k = a.back();

        dp[0][0] = 1;

        for (ll i = 1; i <= n; ++i) {
            dp[i][0] = dp[i - 1][0] + dp[i - 1][1];
            dp[i][0] %= mod;
            dp[i][1] = 1;
            // i - j >= 0
            // j <= i
            for (ll j = k; i - j >= 0; ++j) {
                dp[i][1] += dp[i - j][1];
                dp[i][1] %= mod;
            }
        }

        cout << (dp[n][0] + dp[n][1]) % mod << endl;
    } else {
        vi indexof(9);
        for (int i = 0; i < m; ++i) {
            indexof[a[i]] = i;
        }

        auto isok = [&](const deque<ll> &arr) -> bool {
            vi last(m, -1e18);
            for (int i = 0; i < arr.size(); ++i) {
                if (i - last[arr[i]] < a[arr[i]]) return false;
                last[arr[i]] = i;
            }
            return true;
        };

        auto decompose = [&](ll mask) -> deque<ll> {
            deque<ll> arr;
            for (int i = 0; i < m - 1; ++i) {
                arr.emplace_back(mask % m);
                mask /= m;
            }
            return arr;
        };

        auto compose = [&](deque<ll> arr) -> ll {
            ll mask = 0;
            reverse(arr.begin(), arr.end());
            for (auto e: arr) {
                mask *= m;
                mask += e;
            }
            return mask;
        };

        if (n < m - 1) {
            ll maxmask = ipow(m, n);
            ll ans = 0;

            for (ll mask = 0; mask < maxmask; ++mask) {
                deque<ll> arr;
                for (int i = 0; i < n; ++i) {
                    arr.emplace_back(mask % m);
                    mask /= m;
                }
                if (isok(arr)) {
                    ans += 1;
                }
            }

            cout << (ans % mod) << endl;
            return;
        }

        ll maxmask = ipow(m, m - 1);
        vvi dp(n + 1, vi(maxmask));
        // start from len=m - 1
        for (ll mask = 0; mask < maxmask; ++mask) {
            if (isok(decompose(mask))) {
                dp[m - 1][mask] = 1;
            }
        }

        for (ll i = m; i <= n; ++i) {
            for (ll j = 0; j < m; ++j) {
                for (ll mask = 0; mask < maxmask; ++mask) {
                    deque<ll> arr = decompose(mask);
                    arr.emplace_front(j);
                    if (isok(arr)) {
                        arr.pop_back();
                        ll mask2 = compose(arr);
                        dp[i][mask2] += dp[i - 1][mask];
                        dp[i][mask2] %= mod;
                    }
                }
            }
        }

        ll sum = 0;
        for (ll mask = 0; mask < maxmask; ++mask) {
            sum += dp[n][mask];
            sum %= mod;
        }
        cout << sum << endl;
    }
}