#include <bits/extc++.h>

using namespace std;
using ll = long long;
using ii = pair<ll, ll>;
using vi = vector<ll>;
using vb = vector<bool>;
using vvi = vector<vi>;
using vii = vector<ii>;
using vvii = vector<vii>;
using vvb = vector<vb>;
using ld = long double;

void solve();

int main() {
#ifdef DEBUG
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(25);

    solve();
}

template<class A, class B, class C>
istream &operator>>(istream &s, tuple<A, B, C> &t) {
    return s >> get<0>(t) >> get<1>(t) >> get<2>(t);
}

template<class A, class B>
istream &operator>>(istream &s, pair<A, B> &p) {
    return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
    for (auto &e: v) s >> e;
    return s;
}

#ifndef DEBUG
#define endl '\n'
#endif

using si = __int128_t;

constexpr ll mod = 1e9 + 7;

ll ipow(ll b, ll e) {
    ll res = 1;
    for (int i = 0; i < e; ++i) {
        res *= b;
    }
    return res;
}


void solve() {
    ll n, m;
    cin >> n >> m;

    vi a(m);
    cin >> a;
    sort(a.begin(), a.end());

    ll k = a.back();

    auto isok = [&](const deque<ll> &arr) -> bool {
        vi last(m, -1e18);
        for (int i = 0; i < arr.size(); ++i) {
            if (i - last[arr[i]] < a[arr[i]]) return false;
            last[arr[i]] = i;
        }
        return true;
    };

    auto decompose = [&](ll mask) -> deque<ll> {
        deque<ll> arr;
        for (int i = 0; i < k - 1; ++i) {
            arr.emplace_back(mask % m);
            mask /= m;
        }
        return arr;
    };

    auto compose = [&](deque<ll> arr) -> ll {
        ll mask = 0;
        reverse(arr.begin(), arr.end());
        for (auto e: arr) {
            mask *= m;
            mask += e;
        }
        return mask;
    };

    if (n < k - 1) {
        ll maxmask = ipow(m, n);
        ll ans = 0;

        for (ll mask = 0; mask < maxmask; ++mask) {
            deque<ll> arr;
            for (int i = 0; i < n; ++i) {
                arr.emplace_back(mask % m);
                mask /= m;
            }
            if (isok(arr)) {
                ans += 1;
            }
        }

        cout << (ans % mod) << endl;
        return;
    }

    ll maxmask = ipow(m, k - 1);
    vvi dp(n + 1, vi(maxmask));
    // start from len=m - 1
    for (ll mask = 0; mask < maxmask; ++mask) {
        if (isok(decompose(mask))) {
            dp[k - 1][mask] = 1;
        }
    }

    for (ll i = k; i <= n; ++i) {
        for (ll j = 0; j < m; ++j) {
            for (ll mask = 0; mask < maxmask; ++mask) {
                deque<ll> arr = decompose(mask);
                arr.emplace_front(j);
                if (isok(arr)) {
                    arr.pop_back();
                    ll mask2 = compose(arr);
                    dp[i][mask2] += dp[i - 1][mask];
                    dp[i][mask2] %= mod;
                }
            }
        }
    }

    ll sum = 0;
    for (ll mask = 0; mask < maxmask; ++mask) {
        sum += dp[n][mask];
        sum %= mod;
    }
    cout << sum << endl;

}