#include <bits/extc++.h>

using namespace std;
using ll = long long;
using ii = pair<ll, ll>;
using vi = vector<ll>;
using vb = vector<bool>;
using vvi = vector<vi>;
using vii = vector<ii>;
using vvii = vector<vii>;
using vvb = vector<vb>;
using ld = long double;

void solve();

int main() {
#ifdef DEBUG
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(25);

    solve();
}

template<class A, class B, class C>
istream &operator>>(istream &s, tuple<A, B, C> &t) {
    return s >> get<0>(t) >> get<1>(t) >> get<2>(t);
}

template<class A, class B>
istream &operator>>(istream &s, pair<A, B> &p) {
    return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
    for (auto &e: v) s >> e;
    return s;
}

#ifndef DEBUG
#define endl '\n'
#endif

using si = __int128_t;

constexpr ll mod = 1e9 + 7;

ll ipow(ll b, ll e) {
    ll res = 1;
    for (int i = 0; i < e; ++i) {
        res *= b;
    }
    return res;
}

class segtree {
public:
    void build(const vi &a) {
        n = 1ll << (ll) (ceil(log2(a.size())));
        tree.resize(2 * n);
        build(1, 0, n, a);
    }

    ii query(ll l, ll r) {
        return query(1, 0, n, l, r);
    }

    ii query_p(ll l, ll r, ll p) {
        return query_p(1, 0, n, l, r, p);
    }

    ii query_pr(ll l, ll r, ll p) {
        return query_pr(1, 0, n, l, r, p);
    }

private:
    ll n{};
    vii tree;

    void build(ll v, ll l, ll r, const vi &a) {
        if (l + 1 == r) {
            if (l < a.size()) {
                tree[v] = {a[l], l};
            } else {
                tree[v] = {0, n};
            }
            return;
        }
        ll m = (l + r) / 2;
        build(2 * v, l, m, a);
        build(2 * v + 1, m, r, a);
        tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
    }

    ii query(ll v, ll l, ll r, ll ql, ll qr) {
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        if (qr <= l || r <= ql) {
            return {0, n};
        }
        ll m = (l + r) / 2;
        return merge(query(2 * v, l, m, ql, qr),
                     query(2 * v + 1, m, r, ql, qr));
    }

    ii query_p(ll v, ll l, ll r, ll ql, ll qr, ll p) {
        if (ql <= l && r <= qr) {
            if (tree[v].first < p) {
                return {0, n};
            } else if (tree[v].second == l) {
                return tree[v];
            }
        }
        if (qr <= l || r <= ql) {
            return {0, n};
        }
        ll m = (l + r) / 2;
        ii a = query_p(2 * v, l, m, ql, qr, p);
        if (a.first > p) return a;
        return query_p(2 * v + 1, m, r, ql, qr, p);
    }

    ii query_pr(ll v, ll l, ll r, ll ql, ll qr, ll p) {
        if (ql <= l && r <= qr) {
            if (tree[v].first < p) {
                return {0, n};
            } else if (tree[v].second + 1 == r) {
                return tree[v];
            }
        }
        if (qr <= l || r <= ql) {
            return {0, n};
        }
        ll m = (l + r) / 2;
        ii b = query_pr(2 * v + 1, m, r, ql, qr, p);
        if (b.first > p) return b;
        return query_pr(2 * v, l, m, ql, qr, p);
    }


    ii merge(ii a, ii b) {
        return max(a, b);
    }
};

void solve() {
    ll n, q;
    cin >> n >> q;
    vi a(n);
    cin >> a;

    segtree st;
    st.build(a);

    for (int qq = 0; qq < q; ++qq) {
        ll p, k;
        cin >> p >> k;
        --p, --k;
        ll ans = 0;
        if (k == 0) {
            ans = 1;
        } else {
            if (p >= k) {
                ll c = (p == k ? (ll) 1e18 : a[p - k - 1]);
                ll v = a[p];
                if (c > v) {
                    ii mx = st.query(p - k, p);
                    ii gv = st.query_p(p - k, p, v);
                    if (mx.first > c) {
                        if (gv.first > v && gv.second < mx.second) {
                            // nothing
                        } else {
                            ans += 1;
                        }
                    } else {
                        if (gv.first < v) {
                            ans += k;
                        } else {
                            // [p - k; gv.second]
                            ans += gv.second - (p - k) + 1;
                        }
                    }
                } else {
                    // nothing
                }
            }
            if (p + k < n) {
                ll c = (p + k == n - 1 ? (ll) 1e18 : a[p + k + 1]);
                ll v = a[p];
                if (c > v) {
                    ii mx = st.query(p + 1, p + k + 1);
                    ii gv = st.query_pr(p + 1, p + k + 1, v);
                    if (mx.first > c) {
                        if (gv.first > v && gv.second > mx.second) {
                            // nothing
                        } else {
                            ans += 1;
                        }
                    } else {
                        if (gv.first < v) {
                            ans += k;
                        } else {
                            // [gv.second; p + k];
                            ans += (p + k) - gv.second + 1;
                        }
                    }
                } else {
                    // nothing
                }
            }
        }

        cout << ans << endl;
    }
}