#include <bits/extc++.h>

using namespace std;
using ll = long long;
using ii = pair<ll, ll>;
using vi = vector<ll>;
using vb = vector<bool>;
using vvi = vector<vi>;
using vii = vector<ii>;
using vvii = vector<vii>;
using vvb = vector<vb>;
using ld = long double;

void solve();

int main() {
#ifdef DEBUG
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(25);

    solve();
}

template<class A, class B, class C>
istream &operator>>(istream &s, tuple<A, B, C> &t) {
    return s >> get<0>(t) >> get<1>(t) >> get<2>(t);
}

template<class A, class B>
istream &operator>>(istream &s, pair<A, B> &p) {
    return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
    for (auto &e: v) s >> e;
    return s;
}

#ifndef DEBUG
#define endl '\n'
#endif

using si = __int128_t;

constexpr ll mod = 1e9 + 7;

ll ipow(ll b, ll e) {
    ll res = 1;
    for (int i = 0; i < e; ++i) {
        res *= b;
    }
    return res;
}


void solve() {
    ll G, Q;
    cin >> G >> Q;
    vector<string> q(Q);
    cin >> q;

    auto count2 = [&](const string &s) {
        vi cnt(9);
        for (int i = 1; i < s.size(); ++i) {
            char x = s[i - 1], y = s[i];
            if (x == 'a' && y == 'a') ++cnt[0];
            if (x == 'a' && y == 'b') ++cnt[1];
            if (x == 'a' && y == 'c') ++cnt[2];
            if (x == 'b' && y == 'a') ++cnt[3];
            if (x == 'b' && y == 'b') ++cnt[4];
            if (x == 'b' && y == 'c') ++cnt[5];
            if (x == 'c' && y == 'a') ++cnt[6];
            if (x == 'c' && y == 'b') ++cnt[7];
            if (x == 'c' && y == 'c') ++cnt[8];
        }
        return cnt;
    };

    for (const auto &s: q) {
        ll n = (ll) s.size();
        vi cnt = count2(s);
        if (G == 0 || G == 3) {
            ll ans = 0;
            ll maxmask = ipow(3, n);
            for (ll mask2 = 0; mask2 < maxmask; ++mask2) {
                string t;
                ll mask = mask2;
                for (int i = 0; i < n; ++i) {
                    t.push_back('a' + (mask % 3));
                    mask /= 3;
                }
                vi cnt2 = count2(t);
                if (cnt == cnt2) ++ans;
            }

            cout << ans << endl;
        } else {
#ifdef DEBUG
            abort();
#endif
        }
    }
}